rawset(_G, 'L_ZCollide', function(mo1,mo2)
	if mo1.z > mo2.height+mo2.z then return false end
	if mo2.z > mo1.height+mo1.z then return false end
	return true
end)

G_AddGametype({
    name = "Pizza Time!",
    identifier = "pizzatime",
    typeoflevel = TOL_RACE,
    rules = GTR_SPAWNENEMIES|GTR_RACE|GTR_FRIENDLYFIRE,
    intermissiontype = int_race,
    headercolor = 103,
	description = 'Reach to the end to start Pizza Time, which Players will have to run back to spawn'
})

local PizzaTime = {
	PizzaTime = false,
	SomeoneReachedL2 = false,
	Defined = false,
	EndPoint = {},
	SpawnPoint = {},
	SetSpawn = false,
	PizzaFaceTime = 350,
	PizzaFace = false,
	CanReachLap3 = false,
	Lap3 = false,
	MapChanged = false,
}

local DefinedSpawn = false

local function PizzaTimeExitAction(player)
	if (player.lap == 2 and player.rings < 60 and not PizzaTime.Lap3) or player.lap == 3 then
		return true -- we have exited safely
	elseif (player.lap == 2 and player.rings >= 60 and not PizzaTime.Lap3) or player.lap < 2
		return false -- prepare to run again
	end
end

addHook('NetVars', function(net)
	PizzaTime = net($)
	DefinedSpawn = net($)
end)

addHook('MapChange', function() -- Resets variables on Map Change
	PizzaTime.PizzaTime = false
	PizzaTime.SomeoneReachedL2 = false
	PizzaTime.EndPoint = {}
	PizzaTime.SpawnPoint = {}
	PizzaTime.SetSpawn = false
	PizzaTime.PizzaFaceTime = 350
	PizzaTime.PizzaFace = false
	PizzaTime.CanReachLap3 = false
	PizzaTime.Lap3 = false
	PizzaTime.MapChanged = true
	DefinedSpawn = false
end)

local function PlayerSpawn(player) -- trigger shit om spawn
	if gametype ~= GT_PIZZATIME then return end
	if player.spawned == nil then player.spawned = false end
	if player.lap == nil then player.lap = 0 end
	if player.notDefined == nil then player.notDefined = true end
	if player.notDefined then
		player.isPizzaFace = false
		player.hurtableTimer = 0
		player.hasDied = false
		player.spectator = false
		player.notDefined = false
		if not player.isPizzaFace then player.mo.color = player.skincolor
		player.mo.colorized = false end
		if not DefinedSpawn then
			PizzaTime.SpawnPoint = {
				x = player.mo.x,
				y = player.mo.y,
				z = player.mo.z,
				a = player.mo.angle
			}
			DefinedSpawn = true
		end
	end

	if PizzaTime.PizzaTime then
		--[[if PizzaTime.SomeoneReachedL2 then
			S_ChangeMusic('DEAOIL', true, player)
		else
			S_ChangeMusic('PIZTIM', true, player)
		end--]]
		P_TeleportMove(player.mo, PizzaTime.EndPoint.x, PizzaTime.EndPoint.y, PizzaTime.EndPoint.z)
	end

	player.spawned = true -- good to go enjoy ur run good sir
end

addHook('MapLoad', function()
	if gametype ~= GT_PIZZATIME then return end
	for players in players.iterate do
		if players.lap ~= nil then players.lap = nil end
		players.spawned = false
		players.notDefined = true
		PlayerSpawn(players)
	end
end)

addHook('PlayerSpawn', PlayerSpawn)

addHook('PlayerThink', function(player) -- Dead Trigger (for anti cheat shit!!!)
	if gametype ~= GT_PIZZATIME then return end
	if player.playerstate == PST_DEAD then player.respawned = false end
end)

addHook('PlayerThink', function(player) -- Pizza Time Stuff
	if gametype ~= GT_PIZZATIME then return end
	if not player.mo or player.mo and not player.mo.valid then return end
	if not player.spawned then return end
	if leveltime < 4 * TICRATE then 
		PlayerSpawn(player)
		return
	end

	if player.isPizzaFace then
		player.mo.color = SKINCOLOR_ORANGE
		player.mo.colorized = true
		P_SetScale(player.mo, 2*FRACUNIT)
		player.hurtableTimer = $+1
		local listOfSpectatingPlayers = 0
		local listofOverallPlayers = 0
		for player2 in players.iterate do
			if player2.isPizzaFace or player2.exiting then continue end
			listofOverallPlayers = $+1
			if player2.spectator then
				listOfSpectatingPlayers = $+1
			end
		end
		if listOfSpectatingPlayers >= listofOverallPlayers then
			for player2 in players.iterate do
				P_DoPlayerExit(player2)
			end
		end
	end
	if player.hasDied and not player.spectator then
		player.spectator = true
	end
	if player.mo and player.mo.valid then
		if player.mo.subsector.sector.special == 8192 and not PizzaTime.PizzaTime then
			PizzaTime.PizzaTime = true
			player.isPizzaFace = true
			PizzaTime.EndPoint.x,PizzaTime.EndPoint.y,PizzaTime.EndPoint.z = player.mo.x,player.mo.y,player.mo.z
			chatprint('* '..player.name..' has became Pizza Face and started Pizza Time! Run to the beginning!')
			local sign = P_SpawnMobj(PizzaTime.SpawnPoint.x, PizzaTime.SpawnPoint.y, PizzaTime.SpawnPoint.z, MT_SIGN)
			sign.angle = PizzaTime.SpawnPoint.a
			mapmusname = 'PIZTIM'
			S_ChangeMusic('PIZTIM', true)

			for players in players.iterate do
				players.lap = 1
				P_TeleportMove(players.mo, player.mo.x, player.mo.y, player.mo.z)
			end
			-- Triggers Pizza Time.
		end

		if PizzaTime.PizzaTime then
			local dist = {
				x = abs(player.mo.x - PizzaTime.SpawnPoint.x),
				y = abs(player.mo.y - PizzaTime.SpawnPoint.y),
				z = abs(player.mo.z - PizzaTime.SpawnPoint.z)
			}
			local maxDist = 64*FRACUNIT
			if dist.x <= maxDist and dist.y <= maxDist and not player.isPizzaFace then
				-- player exit action
				local isItAExit = PizzaTimeExitAction(player)
				if not isItAExit then
					P_TeleportMove(player.mo, PizzaTime.EndPoint.x, PizzaTime.EndPoint.y, PizzaTime.EndPoint.z)
					player.lap = $+1
					if player.lap == 2 then
						chatprint('* '..player.name..' has reached Lap 2! Hurry!')
						if not PizzaTime.Lap3 then
							mapmusname = 'DEAOIL'
							S_ChangeMusic('DEAOIL', true)
						end
					elseif player.lap == 3 then
						if not PizzaTime.Lap3 then
							for players in players.iterate do
								if players ~= player then
									players.isPizzaFace = true
									players.hurtableTimer = 0
								else
									player.lap = 1
								end
								if players.exiting and players.mo then
									players.exiting = 0
									P_TeleportMove(players.mo, PizzaTime.EndPoint.x, PizzaTime.EndPoint.y, PizzaTime.EndPoint.z)
								end
							end
							chatprint('* WHAT THE FUCK? '..string.upper(player.name)..' HAS MADE ALL PLAYERS BECOME A PIZZA FACE AND A NEW LAP HAS BEEN ADDED! (their laps have been reseted)')
							PizzaTime.Lap3 = true
							P_SetupLevelSky(34)
							mapmusname = 'PALAVI'
							S_ChangeMusic('PALAVI', true)
						else
							chatprint(player.name..' HAS REACHED LAP 3! GO GO GO!')
						end
					end
				else
					if player.exiting == 0 then
						P_DoPlayerExit(player)
					end
				end
			end
		end
	end
end)

addHook('MobjCollide', function(mo, mo2)
	if not L_ZCollide(mo,mo2) then return end
	if not mo.player.isPizzaFace then return end
	if mo.player.hurtableTimer > 5 * TICRATE then
		if mo2.player and not mo2.player.isPizzaFace and not mo2.player.hasDied and not mo2.player.exiting then
			P_DamageMobj(mo2, mo, mo, 999, DMG_INSTAKILL)
			mo2.player.hasDied = true
			chatprint(mo2.player.name..' has died.')
		end
	end
end, MT_PLAYER)
//Fake Colormap
local function FakeColormap(v, player, cum)
		if player
		and player.valid
		and PizzaTime.Lap3
			v.draw(0, 0, v.cachePatch("LVLPAL"), V_80TRANS|V_SNAPTOTOP|V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RED))
		end
end

hud.add(FakeColormap, "game")