rawset(_G, 'L_ZCollide', function(mo1,mo2)
	if mo1.z > mo2.height+mo2.z then return false end
	if mo2.z > mo1.height+mo1.z then return false end
	return true
end)

G_AddGametype({
  name = "Pizza Time! - 1V1",
  identifier = "pizzatime1v1",
  typeoflevel = TOL_RACE,
  rules = GTR_SPAWNENEMIES|GTR_RACE|GTR_FRIENDLYFIRE,
  intermissiontype = int_race,
  headercolor = 103,
	description = '2 players will have to reach the end, first becomes Pizzaface while the second runs.'
})

local PizzaTime1V1 = {
	PizzaTime = false,
	SomeoneReachedL2 = false,
	Defined = false,
	EndPoint = {},
	SpawnPoint = {},
	SetSpawn = false,
	PizzaFaceTime = 350,
	PizzaFace = false,
	PizzaTimeCount = 0,
	CanReachLap3 = false,
	Lap3 = false,
	MapChanged = false,
}

local DefinedSpawn = false

addHook('NetVars', function(net)
	PizzaTime1V1 = net($)
	DefinedSpawn = net($)
end)

addHook('MapChange', function() -- Resets variables on Map Change
	PizzaTime1V1.PizzaTime = false
	PizzaTime1V1.SomeoneReachedL2 = false
	PizzaTime1V1.EndPoint = {}
	PizzaTime1V1.SpawnPoint = {}
	PizzaTime1V1.SetSpawn = false
	PizzaTime1V1.PizzaFaceTime = 350
	PizzaTime1V1.PizzaFace = false
	PizzaTime1V1.CanReachLap3 = false
	PizzaTime1V1.PizzaTimeCount = 0
	PizzaTime1V1.Lap3 = false
	PizzaTime1V1.MapChanged = true
	DefinedSpawn = false
end)

local function PlayerSpawn(player) -- trigger shit om spawn
	if gametype ~= GT_PIZZATIME1V1 then return end
	if player.spawned == nil then player.spawned = false end
	if player.lap == nil then player.lap = 0 end
	if player.notDefined == nil then player.notDefined = true end
	if player.notDefined then
		player.isPizzaFace = false
		player.hasGotToTheEnd = false
		player.placedIn = 0
		player.hurtableTimer = 0
		player.hasDied = false
		player.spectator = false
		player.notDefined = false
		if not player.isPizzaFace then player.mo.color = player.skincolor
		player.mo.colorized = false end
		if not DefinedSpawn then
			PizzaTime1V1.SpawnPoint = {
				x = player.mo.x,
				y = player.mo.y,
				z = player.mo.z,
				a = player.mo.angle
			}
			DefinedSpawn = true
		end
		player.notDefined = false
	end

	if PizzaTime1V1.PizzaTime then
		--[[if PizzaTime1V1.SomeoneReachedL2 then
			S_ChangeMusic('DEAOIL', true, player)
		else
			S_ChangeMusic('PIZTIM', true, player)
		end--]]
		P_TeleportMove(player.mo, PizzaTime1V1.EndPoint.x, PizzaTime1V1.EndPoint.y, PizzaTime1V1.EndPoint.z)
	end

	player.spawned = true -- good to go enjoy ur run good sir
end

addHook('MapLoad', function()
	if gametype ~= GT_PIZZATIME1V1 then return end
	for players in players.iterate do
		if players.lap ~= nil then players.lap = nil end
		players.spawned = false
		players.notDefined = true
		PlayerSpawn(players)
	end
end)

addHook('PlayerSpawn', PlayerSpawn)

addHook('PlayerThink', function(player) -- Dead Trigger (for anti cheat shit!!!)
	if gametype ~= GT_PIZZATIME1V1 then return end
	if player.playerstate == PST_DEAD then player.respawned = false end
end)

addHook('PlayerThink', function(player) -- Pizza Time Stuff
	if gametype ~= GT_PIZZATIME1V1 then return end
	if not player.mo or player.mo and not player.mo.valid then return end
	if not player.spawned then return end
	if leveltime < 4 * TICRATE then 
		PlayerSpawn(player)
		return
	end

	if player.isPizzaFace then
		player.mo.color = SKINCOLOR_ORANGE
		player.mo.colorized = true
		P_SetScale(player.mo, 2*FRACUNIT)
		player.hurtableTimer = $+1
		local listOfSpectatingPlayers = 0
		local listofOverallPlayers = 0
		for player2 in players.iterate do
			if player2.isPizzaFace or player2.exiting then continue end
			listofOverallPlayers = $+1
			if player2.spectator then
				listOfSpectatingPlayers = $+1
			end
		end
		if listOfSpectatingPlayers >= listofOverallPlayers then
			for player2 in players.iterate do
				P_DoPlayerExit(player2)
			end
		end
	end
	if player.hasDied or (PizzaTime1V1.PizzaTime and not player.hasGotToTheEnd) and not player.spectator then
		player.spectator = true
	end
	if player.mo and player.mo.valid then
		if player.mo.subsector.sector.special == 8192 and not player.hasGotToTheEnd and not PizzaTime1V1.PizzaTime1V1 then
			player.hasGotToTheEnd = true
			PizzaTime1V1.PizzaTimeCount = $+1
			player.placedIn = PizzaTime1V1.PizzaTimeCount
			PizzaTime1V1.EndPoint.x,PizzaTime1V1.EndPoint.y,PizzaTime1V1.EndPoint.z = player.mo.x,player.mo.y,player.mo.z
		end

		if not PizzaTime1V1.PizzaTime then
			local player1 = nil
			local player2 = nil
			for players in players.iterate do
				if not players.mo or (players.mo and not players.mo.valid) then continue end
				if players.hasGotToTheEnd then
					if player1 == nil then
						player1 = players
						continue
					elseif player1 ~= nil then
						player2 = players
					end
				end
			end
			if player1 == nil or player2 == nil then return end
			PizzaTime1V1.PizzaTime = true
			chatprint(player1.name..' and '..player2.name..' has started the 1V1!')
			P_SetupLevelSky(34)
			mapmusname = 'DEAMOD'
			S_ChangeMusic('DEAMOD', true)
			local sign = P_SpawnMobj(PizzaTime1V1.SpawnPoint.x, PizzaTime1V1.SpawnPoint.y, PizzaTime1V1.SpawnPoint.z, MT_SIGN)
			sign.angle = PizzaTime1V1.SpawnPoint.a
			if player1.placedIn == 1 then
				player1.isPizzaFace = true
			elseif player2.placedIn == 1 then
				player2.isPizzaFace = true
			end
		end

		if PizzaTime1V1.PizzaTime then
			local dist = {
				x = abs(player.mo.x - PizzaTime1V1.SpawnPoint.x),
				y = abs(player.mo.y - PizzaTime1V1.SpawnPoint.y),
				z = abs(player.mo.z - PizzaTime1V1.SpawnPoint.z)
			}
			local maxDist = 64*FRACUNIT
			if dist.x <= maxDist and dist.y <= maxDist and not player.isPizzaFace then
				-- player exit action
				if player.lap < 10
					P_TeleportMove(player.mo, PizzaTime1V1.EndPoint.x, PizzaTime1V1.EndPoint.y, PizzaTime1V1.EndPoint.z)
					player.lap = $+1
					chatprint(player.name..' has reached Lap '..player.lap..'!')
				else
					P_DoPlayerExit(player)
					chatprint(player.name..' has escaped!')
				end
			end
		end
	end
end)

addHook('MobjCollide', function(mo, mo2)
	if not L_ZCollide(mo,mo2) then return end
	if not mo.player.isPizzaFace then return end
	if mo.player.hurtableTimer > 5 * TICRATE then
		if mo2.player and not mo2.player.isPizzaFace and not mo2.player.hasDied and not mo2.player.exiting then
			P_DamageMobj(mo2, mo, mo, 999, DMG_INSTAKILL)
			mo2.player.hasDied = true
			chatprint(mo2.player.name..' has died.')
		end
	end
end, MT_PLAYER)
//Fake Colormap
local function FakeColormap(v, player, cum)
		if player
		and player.valid
		and PizzaTime1V1.PizzaTime then
			v.draw(0, 0, v.cachePatch("LVLPAL"), V_80TRANS|V_SNAPTOTOP|V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RED))
		end
end

hud.add(FakeColormap, "game")